#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "cputime.h"

MODULE = Sys::CPUtime		PACKAGE = Sys::CPUtime		

int
timelimit()

    CODE:
	rlim_t i;
	getrlimit (RLIMIT_CPU, &limit);
  	i = limit.rlim_cur;
  	RETVAL = i;
	if (i == RLIM_INFINITY) XSRETURN_UNDEF;

    OUTPUT:
	RETVAL

int
used_utime()

    CODE:
	int i;
	getrusage (RUSAGE_SELF, &usage);
  	i = usage.ru_utime.tv_sec;
  	RETVAL = i;

    OUTPUT:
	RETVAL


int
used_stime()

    CODE:
	int i;
	getrusage (RUSAGE_SELF, &usage);
  	i = usage.ru_stime.tv_sec;
  	RETVAL = i;

    OUTPUT:
	RETVAL

long
remained_time()

    CODE:
	long int i;
	getrlimit (RLIMIT_CPU, &limit);
  	i = limit.rlim_cur;
	if (i == RLIM_INFINITY) {
		i= LONG_MAX;
	} else {
		getrusage (RUSAGE_SELF, &usage);
	  	i-= usage.ru_utime.tv_sec;
  		i-= usage.ru_stime.tv_sec;
		i-=2; /* rounding roughly */
	}
  	RETVAL = i;

    OUTPUT:
	RETVAL

long
process_time()

    CODE:
	long int i;
	/* to do: convert to float */
	getrusage (RUSAGE_SELF, &usage);
	i =usage.ru_utime.tv_sec;
  	i+=usage.ru_stime.tv_sec;
  	RETVAL = i;

    OUTPUT:
	RETVAL
